#ifndef EULER_KINETIC_SOLVER_ACOUSTIC_LAGRANGE_FV_HPP
#define EULER_KINETIC_SOLVER_ACOUSTIC_LAGRANGE_FV_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::tuple<std::shared_ptr<const MeshVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
eulerKineticSolverAcousticLagrangeFV(const double& dt,
                                     const std::vector<double>& lambda_vector,
                                     const double& gamma,
                                     const double& eps,
                                     const size_t& space_order,
                                     const size_t& time_order,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& rho,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& u,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& E,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& p);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
getEulerKineticExactSolutionAcousticLagrangeFV(const double& t,
                                               const double& gamma,
                                               const std::shared_ptr<const DiscreteFunctionVariant>& rho_ex,
                                               const std::shared_ptr<const DiscreteFunctionVariant>& u_ex,
                                               const std::shared_ptr<const DiscreteFunctionVariant>& p_ex,
                                               const std::shared_ptr<const DiscreteFunctionVariant>& rho_u_ex,
                                               const std::shared_ptr<const DiscreteFunctionVariant>& rho_E_ex);

#endif   // EULER_KINETIC_SOLVER_ACOUSTIC_LAGRANGE_FV_HPP
