#ifndef EULER_KINETIC_SOLVER_LAGRANGE_FV_HPP
#define EULER_KINETIC_SOLVER_LAGRANGE_FV_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
getEulerKineticWavesLagrangeFV(const std::vector<double>& lambda_vector,
                               const std::shared_ptr<const DiscreteFunctionVariant>& tau,
                               const std::shared_ptr<const DiscreteFunctionVariant>& u,
                               const std::shared_ptr<const DiscreteFunctionVariant>& E,
                               const double& gamma);

std::tuple<std::shared_ptr<const MeshVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
eulerKineticSolverLagrangeFV(const double& dt,
                             const double& gamma,
                             const std::vector<double>& lambda_vector,
                             const size_t& space_order,
                             const size_t& time_order,
                             const double& eps,
                             const std::shared_ptr<const DiscreteFunctionVariant>& F_tau,
                             const std::shared_ptr<const DiscreteFunctionVariant>& F_u,
                             const std::shared_ptr<const DiscreteFunctionVariant>& F_E);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
getEulerKineticExactSolutionLagrangeFV(const double& t,
                                       const double& gamma,
                                       const std::shared_ptr<const DiscreteFunctionVariant>& rho_ex,
                                       const std::shared_ptr<const DiscreteFunctionVariant>& u_ex,
                                       const std::shared_ptr<const DiscreteFunctionVariant>& p_ex,
                                       const std::shared_ptr<const DiscreteFunctionVariant>& rho_u_ex,
                                       const std::shared_ptr<const DiscreteFunctionVariant>& rho_E_ex);

#endif   // EULER_KINETIC_SOLVER_LAGRANGE_FV_HPP
