#ifndef EULER_KINETIC_SOLVER_LAGRANGE_MULTID_LOCAL_HPP
#define EULER_KINETIC_SOLVER_LAGRANGE_MULTID_LOCAL_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

class IBoundaryConditionDescriptor;

std::tuple<std::shared_ptr<const MeshVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
eulerKineticSolverLagrangeMultiDLocal(
  const double& dt,
  const size_t& L,
  const size_t& M,
  const size_t& k,
  const double& gamma,
  const double& eps,
  const size_t& space_order,
  const size_t& time_order,
  const std::shared_ptr<const DiscreteFunctionVariant>& rho,
  const std::shared_ptr<const DiscreteFunctionVariant>& u,
  const std::shared_ptr<const DiscreteFunctionVariant>& E,
  const std::shared_ptr<const DiscreteFunctionVariant>& p,
  const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list);

#endif   // EULER_KINETIC_SOLVER_LAGRANGE_MULTID_LOCAL_HPP
