#ifndef EULER_KINETIC_SOLVER_MULTID_ORDER2_HPP
#define EULER_KINETIC_SOLVER_MULTID_ORDER2_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

class IBoundaryConditionDescriptor;

template <size_t Dimension>
std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
eulerKineticSolverMultiDOrder2(
  const double& dt,
  const double& gamma,
  const std::vector<TinyVector<Dimension>>& lambda_vector,
  const double& eps,
  const size_t& SpaceOrder,
  const size_t& TimeOrder,
  const size_t& scheme,
  const std::shared_ptr<const DiscreteFunctionVariant>& F_rho,
  const std::shared_ptr<const DiscreteFunctionVariant>& F_rho_u,
  const std::shared_ptr<const DiscreteFunctionVariant>& F_rho_E,
  const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list);

#endif   // EULER_KINETIC_SOLVER_MULTID_ORDER2_HPP
