#ifndef EULER_KINETIC_SOLVER_THIRD_ORDER_MOOD_FD_HPP
#define EULER_KINETIC_SOLVER_THIRD_ORDER_MOOD_FD_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
getEulerKineticWavesThirdOrderMoodFD(const std::vector<double>& lambda_vector,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& rho,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& rho_u,
                                     const std::shared_ptr<const DiscreteFunctionVariant>& rho_E,
                                     const double& gamma);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>>
eulerKineticSolverThirdOrderMoodFD(const double& dt,
                                   const double& gamma,
                                   const std::vector<double>& lambda_vector,
                                   const double& eps,
                                   const std::shared_ptr<const DiscreteFunctionVariant>& F_rho,
                                   const std::shared_ptr<const DiscreteFunctionVariant>& F_rho_u,
                                   const std::shared_ptr<const DiscreteFunctionVariant>& F_rho_E);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>, std::shared_ptr<const DiscreteFunctionVariant>>
getEulerKineticExactSolutionThirdOrderMoodFD(const double& t,
                                             const std::shared_ptr<const DiscreteFunctionVariant>& rho_ex,
                                             const std::shared_ptr<const DiscreteFunctionVariant>& u_ex);

#endif   // EULER_KINETIC_SOLVER_THIRD_ORDER_MOOD_FD_HPP
