#ifndef SCALAR_KINETIC_SOLVER_HPP
#define SCALAR_KINETIC_SOLVER_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::shared_ptr<const DiscreteFunctionVariant> getScalarKineticWaves(
  const std::vector<double>& lambda_vector,
  const std::shared_ptr<const DiscreteFunctionVariant>& u,
  const std::shared_ptr<const DiscreteFunctionVariant>& Au);

std::shared_ptr<const DiscreteFunctionVariant> scalarKineticSolver(
  const double& dt,
  const FunctionSymbolId& flux_function_id,
  const std::vector<double>& lambda_vector,
  const double& eps,
  const std::shared_ptr<const DiscreteFunctionVariant>& F);

#endif   // SCALAR_KINETIC_SOLVER_HPP
