#ifndef WAVES_EQUATION_KINETIC_SOLVER_THIRD_ORDER_TIME_FD_HPP
#define WAVES_EQUATION_KINETIC_SOLVER_THIRD_ORDER_TIME_FD_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>, std::shared_ptr<const DiscreteFunctionVariant>>
getWavesEquationKineticWavesThirdOrderTimeFD(const std::vector<double>& lambda_vector,
                                             const std::shared_ptr<const DiscreteFunctionVariant>& u,
                                             const std::shared_ptr<const DiscreteFunctionVariant>& p,
                                             const TinyMatrix<2>& A);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>, std::shared_ptr<const DiscreteFunctionVariant>, double>
wavesEquationKineticSolverThirdOrderTimeFD(const double& dt,
                                           const TinyMatrix<2>& A,
                                           const std::vector<double>& lambda_vector,
                                           const double& eps,
                                           const std::shared_ptr<const DiscreteFunctionVariant>& F_u,
                                           const std::shared_ptr<const DiscreteFunctionVariant>& F_p);

#endif   // WAVES_EQUATION_KINETIC_SOLVER_THIRD_ORDER_TIME_FD_HPP
