#ifndef WAVES_EQUATION_NON_UNIFORM_CELL_KINETIC_SOLVER_HPP
#define WAVES_EQUATION_NON_UNIFORM_CELL_KINETIC_SOLVER_HPP

#include <language/utils/FunctionSymbolId.hpp>
#include <mesh/ItemArrayVariant.hpp>
#include <scheme/DiscreteFunctionVariant.hpp>

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const DiscreteFunctionVariant>,
           std::shared_ptr<const ItemArrayVariant>>
getWavesEquationNonUniformCellKineticWaves(const std::shared_ptr<const DiscreteFunctionVariant>& u,
                                           const std::shared_ptr<const DiscreteFunctionVariant>& p,
                                           const TinyMatrix<2>& A,
                                           const uint64_t& nb_waves,
                                           const double& dt);

std::tuple<std::shared_ptr<const DiscreteFunctionVariant>, std::shared_ptr<const DiscreteFunctionVariant>, double>
wavesEquationNonUniformCellKineticSolver(const double& dt,
                                         const TinyMatrix<2>& A,
                                         const std::shared_ptr<const ItemArrayVariant>& lambda_vector,
                                         const double& eps,
                                         const std::shared_ptr<const DiscreteFunctionVariant>& F_u,
                                         const std::shared_ptr<const DiscreteFunctionVariant>& F_p);

#endif   // WAVES_EQUATION_NON_UNIFORM_CELL_KINETIC_SOLVER_HPP
